PROGRAM test1

  USE mpi

  IMPLICIT NONE

  INTEGER :: ierr,numprocs,myid,numgrpprocs,i,mygid,gsize,csize,myrank
  INTEGER :: mygroup,group,mycomm
  INTEGER, DIMENSION(:), allocatable :: granks  

  CALL MPI_INIT(ierr)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,numprocs,ierr)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,myid,ierr)

  
  numgrpprocs = numprocs-1

  allocate(granks(0:numgrpprocs-1))

  do i=0,numgrpprocs-1
    granks(i)=i
  end do

  write(*,*)numgrpprocs,granks

  CALL MPI_COMM_GROUP(MPI_COMM_WORLD,group,ierr)
  CALL MPI_GROUP_INCL(group,numgrpprocs,granks,mygroup,ierr)
  
  CALL MPI_GROUP_SIZE(mygroup,gsize,ierr)
  CALL MPI_GROUP_RANK(mygroup,mygid,ierr)

  call MPI_COMM_CREATE(MPI_COMM_WORLD,mygroup,mycomm,ierr)

  ! the following two calls lead to error messages on node which is
  ! not a part of mycomm.

  call MPI_COMM_SIZE(mycomm,csize,ierr)
  call MPI_COMM_RANK(mycomm,myrank,ierr)

  WRITE(*,*)myid,numprocs,mygid,gsize,csize,myrank

  CALL MPI_GROUP_FREE(mygroup,ierr)

  deallocate(granks)
  CALL MPI_FINALIZE(ierr)

END PROGRAM test1
