PROGRAM test1

  USE mpi

  IMPLICIT NONE

  INTEGER :: ierr,numprocs,myid,numgrpprocs,i,mygid,gsize
  INTEGER :: mygroup,group
  INTEGER, DIMENSION(:), allocatable :: granks  

  CALL MPI_INIT(ierr)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,numprocs,ierr)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,myid,ierr)

  
  numgrpprocs = numprocs-1

  allocate(granks(0:numgrpprocs-1))

  do i=0,numgrpprocs-1
    granks(i)=i
  end do

  write(*,*)numgrpprocs,granks

  CALL MPI_COMM_GROUP(MPI_COMM_WORLD,group,ierr)
  CALL MPI_GROUP_INCL(group,numgrpprocs,granks,mygroup,ierr)
  
  CALL MPI_GROUP_SIZE(mygroup,gsize,ierr)
  CALL MPI_GROUP_RANK(mygroup,mygid,ierr)

  WRITE(*,*)myid,numprocs,mygid,gsize

  CALL MPI_GROUP_FREE(mygroup,ierr)

  deallocate(granks)
  CALL MPI_FINALIZE(ierr)

END PROGRAM test1
