PROGRAM test1

  USE mpi

  IMPLICIT NONE

  INTEGER :: ierr,numprocs,myid,csize,myrank,itemp
  integer :: direction1,direction2,disp,ranks1,ranks2,rankd1,rankd2
  INTEGER :: mycomm,cartcomm
  logical :: reorder = .true.
  integer, parameter :: ndims=2
  logical, dimension(ndims) :: periods
  integer, dimension(ndims) :: dims,coords

  CALL MPI_INIT(ierr)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,numprocs,ierr)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,myid,ierr)

  call MPI_COMM_DUP(MPI_COMM_WORLD,mycomm,ierr)

  dims(:)=2
  periods(1) = .true.
  periods(2) = .true.

  itemp=ndims

  call MPI_CART_CREATE(mycomm,ndims,dims,periods,reorder,cartcomm&
      &,ierr)

  call MPI_COMM_SIZE(cartcomm,csize,ierr)
  call MPI_COMM_RANK(cartcomm,myrank,ierr)

  WRITE(*,*)myid,numprocs,csize,myrank

  call MPI_CART_COORDS(cartcomm,myrank,itemp,coords,ierr)

  direction1=0
  direction2=1
  disp=1

  call MPI_CART_SHIFT(cartcomm,direction1,disp,ranks1,rankd1,ierr)
  call MPI_CART_SHIFT(cartcomm,direction2,disp,ranks2,rankd2,ierr)

  write(*,*)coords,' ',ranks1,rankd1,' ',ranks2,rankd2

  call MPI_COMM_FREE(mycomm,ierr)

  CALL MPI_FINALIZE(ierr)

END PROGRAM test1

