PROGRAM test2

  USE mpi

  IMPLICIT NONE

  INTEGER :: ierr,numprocs,myid,csize,myrank,itemp
  INTEGER :: direction1,direction2,disp,ranks1,ranks2,rankd1,rankd2
  INTEGER :: mycomm,cartcomm
  LOGICAL :: reorder = .TRUE.
  INTEGER, PARAMETER :: ndims=2
  LOGICAL, DIMENSION(ndims) :: periods
  INTEGER, DIMENSION(ndims) :: dims,coords,coord_s1,coord_s2,coord_d1&
      &,coord_d2

  CALL MPI_INIT(ierr)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,numprocs,ierr)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,myid,ierr)

  CALL MPI_COMM_DUP(MPI_COMM_WORLD,mycomm,ierr)

  dims(:)=2
  periods(1) = .TRUE.
  periods(2) = .TRUE.

  itemp=ndims

  CALL MPI_CART_CREATE(mycomm,ndims,dims,periods,reorder,cartcomm&
      &,ierr)

  CALL MPI_COMM_SIZE(cartcomm,csize,ierr)
  CALL MPI_COMM_RANK(cartcomm,myrank,ierr)

  WRITE(*,*)myid,numprocs,csize,myrank

  CALL MPI_CART_COORDS(cartcomm,myrank,itemp,coords,ierr)

  direction1=0
  direction2=1
  disp=1

  CALL MPI_CART_SHIFT(cartcomm,direction1,disp,ranks1,rankd1,ierr)
  CALL MPI_CART_SHIFT(cartcomm,direction2,disp,ranks2,rankd2,ierr)

  CALL MPI_CART_COORDS(cartcomm,ranks1,itemp,coord_s1,ierr)

  CALL MPI_CART_COORDS(cartcomm,ranks2,itemp,coord_s2,ierr)

  CALL MPI_CART_COORDS(cartcomm,rankd1,itemp,coord_d1,ierr)

  CALL MPI_CART_COORDS(cartcomm,rankd2,itemp,coord_d2,ierr)

  WRITE(*,*)coords,' ',coord_s1,' ',coord_d1,' ',coord_s2,' ',coord_d2

  CALL MPI_COMM_FREE(mycomm,ierr)

  CALL MPI_FINALIZE(ierr)

END PROGRAM test2

