PROGRAM test3

  USE mpi

  IMPLICIT NONE

  INTEGER :: ierr,numprocs,myid,csize,myrank,itemp
  INTEGER :: direction1,direction2,disp,ranks1,ranks2,rankd1,rankd2
  INTEGER :: mycomm,cartcomm
  LOGICAL :: reorder = .TRUE.
  INTEGER, PARAMETER :: ndims=2
  LOGICAL, DIMENSION(ndims) :: periods
  INTEGER, DIMENSION(ndims) :: dims,coords,coord_s1,coord_s2,coord_d1&
      &,coord_d2

  INTEGER :: ngrid=10
  integer, dimension(0:ngrid+1) :: imap
  REAL, DIMENSION(:,:), ALLOCATABLE :: f,f1
  REAL :: g,h

  CALL MPI_INIT(ierr)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,numprocs,ierr)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,myid,ierr)

  CALL MPI_COMM_DUP(MPI_COMM_WORLD,mycomm,ierr)

  dims(:)=2
  periods(1) = .TRUE.
  periods(2) = .TRUE.

  ALLOCATE(f1(dims(1),dims(2)))
  IF (myid .EQ. 0) THEN
    OPEN(99,file='test.dat',status='old')
    DO j=1,dims(2)
      DO i=1,dims(1)
        READ(99,*)f1(i,j)
      END DO
    END DO
    CLOSE(99)
  END IF

  call MPI_BROADCAST()

  itemp=ndims

  CALL MPI_CART_CREATE(mycomm,ndims,dims,periods,reorder,cartcomm&
      &,ierr)

  CALL MPI_COMM_SIZE(cartcomm,csize,ierr)
  CALL MPI_COMM_RANK(cartcomm,myrank,ierr)

  WRITE(*,*)myid,numprocs,csize,myrank

  CALL MPI_CART_COORDS(cartcomm,myrank,itemp,coords,ierr)

  iin=coords(1) * ngrid / 2 + 1
  iout=(coords(1) + 1 ) * ngrid / 2
  jin=coords(2) * ngrid / 2 + 1
  jout=(coords(2) + 1 ) * ngrid / 2

  call allocate(f(iin:iout,jin:jout))
  f(iin:iout,jin:jout)=f1(iin:iout,jin:jout)
  deallocate(f1)


  do j=-1,1
    


  direction1=0
  direction2=1
  disp=1

  CALL MPI_CART_SHIFT(cartcomm,direction1,disp,ranks1,rankd1,ierr)
  CALL MPI_CART_SHIFT(cartcomm,direction2,disp,ranks2,rankd2,ierr)

  CALL MPI_CART_COORDS(cartcomm,ranks1,itemp,coord_s1,ierr)

  CALL MPI_CART_COORDS(cartcomm,ranks2,itemp,coord_s2,ierr)

  CALL MPI_CART_COORDS(cartcomm,rankd1,itemp,coord_d1,ierr)

  CALL MPI_CART_COORDS(cartcomm,rankd2,itemp,coord_d2,ierr)

  WRITE(*,*)coords,' ',coord_s1,' ',coord_d1,' ',coord_s2,' ',coord_d2

  CALL MPI_COMM_FREE(mycomm,ierr)

  CALL MPI_FINALIZE(ierr)

END PROGRAM test3

